//-< DHASH.HPP >-----------------------------------------------------*--------*
// GOODS                     Version 1.0          (c) 1992  GARRET   *     ?  *
// ( Garret object oriented data storage )                           *   /\|  *
// Dynamic extended hash table                                       *  /  \  *
//                           Created:      30-Jul-94   K.A. Knizhnik * / [] \ *
//                           Last update:  30-Jul-94   K.A. Knizhnik * GARRET *
//-------------------------------------------------------------------*--------*

#ifndef  __DHASH_HPP__
 #define  __DHASH_HPP__

 class Dbs_Str_Hash_Table : public File_Object {
   protected:
     struct Block : File_Object {
         nat            Numb; // number of keys in block
         nat            Used; // total size of all keys in block
         tiny           Bits; // number of used bits from hash function value
         char           Keys[1];

         static large   Hash_Func( const char* str );

         File_Object*   Search( const char* str );
         bool           Put( File_Object* obj, const char* str );
         void           Unlink( File_Object* obj );

         File_Object*&  Ref( int i )
           { return *((File_Object**)((char*)this + Dbs_Size) - i - 1); }

         Block*         Fork();

         void Clear() { 
	     Numb = Used = 0; 
	 }
     };
     struct Segment : public File_Object {
         Block*         Ref[1];
         Segment*       Fork();
     };
     struct Segment_List : public File_Object {
         Segment*       Ref[1];
         Segment_List*  Fork();
     };

     Segment_List* List; // list of segments

     nat   Seg_Log_Size; // segment contain 2 ** Seg_Log_Size pointers
     nat   Seg_Log_Numb; // log2(number of segments)
     large Blk_Size;

   public:
     File_Object* Search( const char* str );
     void         Unlink( File_Object* obj, const char* str );
     void         Put   ( File_Object* obj, const char* str );

     Dbs_Str_Hash_Table( int Segment_Log_Size = 10, int Block_Size = 1024 );
 };

#endif

