//-< FSTOR.HPP >-----------------------------------------------------*--------*
// GOODS                     Version 1.0          (c) 1992  GARRET   *     ?  *
// ( Garret object oriented data storage )                           *   /\|  *
// Store mapped on file                                              *  /  \  *
//                           Created:      04-Mar-92   K.A. Knizhnik * / [] \ *
//                           Last update:  16-May-94   K.A. Knizhnik * GARRET *
//-------------------------------------------------------------------*--------*

#ifndef  __FSTOR_HPP__
 #define  __FSTOR_HPP__

 #include "store.hpp"
 #include "pages.hpp"
 #include "filio.hpp"

 class  Dbs_F_Store : public Dbs_Store, public Pool_Store {
   protected:
    unsigned  Page_Self; // bytes of alloction page used to map one page
    unsigned  Page_Size; // size of page in bytes
    large     Last_Page; // address of last allocation page
    large     Bit_Page ; // address of current allocation page
    unsigned  Bit_Base ; // number of current byte in current allocation page
    Dbs_File* File     ;

    void      Save      ( Dbs_Page * Pg );
    void      Load      ( Dbs_Page * Pg );

   public:
    large     Length    ( void );
    large     Start     ( void );
    bool      Empty     ( void );
    void      Flush     ( void );

    void      Read      ( Dbs_Object* Obj );
    void      Write     ( Dbs_Object* Obj );

    large     Malloc    ( o_size_t Size );
    void      Near      ( large Address );
    void      Free      ( large Address, o_size_t Size );
    void      Clear     ( void );

    void      Open      ( int Ident, Object_Database* Base );
    void      Close     ( void );

    Dbs_F_Store         ( Dbs_File& St_File, Dbs_Pool& St_Pool );
 };

#endif
