//-< L2LST.HPP >-----------------------------------------------------*--------*
// Garret Object Class Library                    (c) 1991  GARRET   *     ?  *
//                                                                   *   /\|  *
//                                                                   *  /  \  *
//  Double Linked Lists      Created:      13-OCT-90   I.V. Abramow  * / [] \ *
//    Declarations           Last update:  06-APR-91   I.V. Abramow  * GARRET *
//-------------------------------------------------------------------*--------*

#ifndef __L2LST_HPP__
    #define __L2LST_HPP__

    struct  L2_Elem {
        L2_Elem*    Next;
        L2_Elem*    Prev;

        inline  void    proc    Link( L2_Elem*  After ){
            (Next = After->Next)->Prev = this ;
            (Prev = After)->Next = this ;
        };

        inline  void    proc    Unlink( void ){
            Prev->Next = Next;
            Next->Prev = Prev;
        };

        inline  void    proc    Prune( void ){
            Next = Prev = this ;
        } ;

        inline  bool    proc    Is_Empty( void ){
            return  Next == this;
        };
    };

    struct  L2_Node : L2_Elem {
        void*   Val;
    };

    struct  L2_List {
        L2_Elem     Head;
        L2_Elem*    Curr;

        L2_List( void ){
            Head.Next = Head.Prev = Curr = &Head;
        };

        bool    Is_Empty( void ){
            return  Head.Next == &Head;
        };

        void    To_Start( void ){
            Curr = &Head;
        };

        void    To_Next( void ){
            Curr = Curr->Next;
        };

        void    To_Prev( void ){
            Curr = Curr->Prev;
        };

        bool    At_End( void ){
            return Curr->Next == &Head;
        };

        L2_Elem* Elem( void ){
            return Curr->Next;
        };

    };

#endif
