//-< MFLIO.HPP >-----------------------------------------------------*--------*
// GOODS                     Version 1.0          (c) 1992  GARRET   *     ?  *
// ( Garret object oriented data storage )                           *   /\|  *
// Low level multi file I/O operations                               *  /  \  *
//                           Created:      15-Feb-92   K.A. Knizhnik * / [] \ *
//                           Last update:  10-Mar-92   K.A. Knizhnik * GARRET *
//-------------------------------------------------------------------*--------*

#ifndef __MFLIO_HPP__
 #define __MFLIO_HPP__

 #include "filio.hpp"

 struct Dbs_Segment {
   const char*  Name;
   large       Limit;
 };

 class   Dbs_M_File : public Dbs_File {
   private:
    Dbs_File** Seg     ;
    large *    Limit   ;
    nat        Seg_Num ;
    nat        Curr_Ind;
    large      Curr_Ofs;

   public :
    Dbs_File*  Segment  ( int i )  { return Seg[i]; }

    int        Open     ( int Flags, int Mode=0666);
    int        Close    ( void );
    int        Unlink   ( void );
    int        Access   ( int Mode = 0 );
    int        Write    ( void* Buffer, unsigned Quant );
    int        Read     ( void* Buffer, unsigned Quant );
    large      Seek     ( long  Offset, int Whence=0   );
    void       Sync     ( void ) ;

    Dbs_M_File ( nat Number, Dbs_Segment* Segments );
    ~Dbs_M_File( void );
 };

#endif
