//-< PSTOR.CPP >-----------------------------------------------------*--------*
// GOODS                     Version 1.0          (c) 1992  GARRET   *     ?  *
// ( Garret object oriented data storage )                           *   /\|  *
// Fault protected storage                                           *  /  \  *
//                           Created:      04-Mar-92   K.A. Knizhnik * / [] \ *
//                           Last update:  26-May-92   K.A. Knizhnik * GARRET *
//-------------------------------------------------------------------*--------*

#include <stdio.h>
#include <string.h>
#include "oodbs.hpp"
#include "pstor.hpp"

Dbs_P_Store::Dbs_P_Store(Dbs_File& St_File, Dbs_Pool& St_Pool, Dbs_File& St_Log)
  : Dbs_F_Store( St_File, St_Pool )
    { Log = &St_Log, Buf = new char[ Page_Size + 4 ]; }

void Dbs_P_Store::Open( int Id, Object_Database* Db ) {
    Dbs_F_Store::Open( Id, Db );
    if( Log->Open( O_RDONLY|O_BINARY ) > Ok ) {
        unsigned Quant = Page_Size + 4;
        large Addr = Log->Length() / Quant * Quant;
        while( Addr >= Quant ) {
            Log->Seek( Addr -= Quant );
            Dbs_Check( Log->Read( Buf, Quant ) );
            File->Seek( *(large*)Buf );
            Dbs_Check( File->Write( Buf + 4, Page_Size ) );
        }
        File->Sync();
    }
    Dbs_Check( Log->Open( O_WRONLY|O_CREAT|O_BINARY|O_TRUNC|O_SYNC,
       S_IREAD|S_IWRITE ) > Ok );
}

void Dbs_P_Store::Close() {
    Dbs_F_Store::Close();
    Dbs_Check( Log->Unlink() == Ok );
}

void Dbs_P_Store::Flush() {
    Dbs_F_Store::Flush();
    File->Sync();
    End = File->Length();
    Dbs_Check( Log->Open( O_WRONLY|O_CREAT|O_BINARY|O_TRUNC|O_SYNC,
       S_IREAD|S_IWRITE ) > Ok );
}

void Dbs_P_Store::Save( Dbs_Page* Pg )  {
    File->Seek( Pg->Address );
    if( Pg->Address < End ) {
        Dbs_Check( (unsigned)File->Read( Buf + 4, Page_Size ) == Page_Size );
        *(large*)Buf = Pg->Address;
        Dbs_Check( (unsigned)Log->Write( Buf, Page_Size + 4 ) == Page_Size+4 );
        File->Seek( Pg->Address );
    } else if( !(Pg->Address & ((large(Page_Size) << (Dbs_Slot_Bits+3))-1)) ) {
        *(large*)Buf = Pg->Address;
        memset( Buf+4, 0, Page_Size );
        *(nat*)(Buf+4) = Page_Self;
        Dbs_Check( (unsigned)Log->Write( Buf, Page_Size + 4 ) == Page_Size+4 );
    }
    Dbs_Check( (unsigned)File->Write( Pg->Space, Page_Size ) == Page_Size );
}
