/*-< STDTP.HPP >-----------------------------------------------------*--------*
// Super C integrated environment                 (c) 1991  GARRET   *     ?  *
//  Standart types definitions for portable C programming            *   /\|  *
//  and style improving                                              *  /  \  *
//                           Created:      01-AUG-89   I.V. Abramow  * / [] \ *
//                           Last update:  10-Sep-92   I.V. Abramow  * GARRET *
//-------------------------------------------------------------------*--------*/

#ifndef __STDTP_HPP__
 #define __STDTP_HPP__

 #include    <limits.h>
 #include    <stddef.h>

 #define bool int                /* Introduce more readable boolean type      */
 typedef unsigned char   tiny;   /* Integer for small values                  */
 typedef unsigned short  nat;    /* Medium sized unsigned integer value       */
 typedef unsigned long   large;

 #define TRUE       1            /* Values for bool type                      */
 #define FALSE      0

 #define ON         1            /* Another representation of boolean values  */
 #define OFF        0            /* for some flag variables                   */

 #define YES        1            /* Another representation of boolean values  */
 #define NO         0            /*                                           */

 #define Ok         0            /* Result of some system function execution  */

 #define global                  /* introduce new pseudokeyword               */
 #define export     extern       /* introduce new pseudokeyword               */
 #define import     extern       /* introduce new pseudokeyword               */
 #define local      static       /* introduce new pseudokeyword               */
 #define nobreak

 #ifdef __MSDOS__
    #define proc    pascal
    #define noret
 #else
    #define noret   volatile
    #define proc
    #define far
    #define near
    #define huge
 #endif

 /* Exit codes                                                                */

 #define EX_O_KEY    0           /* Successfully comletion                    */
 #define EX_WARNINGS 1           /* User warned, terminated normally          */
 #define EX_ERRORS   2           /* User is wrong, terminated normally        */
 #define EX_FATAL    3           /* User is very wrong, abandon               */
 #define EX_ABZAC    4           /* Internal error detected                   */

 /* Function Level Exception Handler Definitions                              */

 #define RAISE       goto        /* To raise exception x type "RAISE x;"      */
 #define EXCEPTION               /* To mark exception handler - "EXCEPTION x:"*/

 /* Names of Operating Systems   */

 #define SYS_OS_2    0
 #define SYS_MS_DOS  1
 #define SYS_UNIX    2
 #define SYS_VAX_VMS 3
 #define SYS_RSX     4

 #ifndef HOST_OS
     #define HOST_OS     SYS_UNIX
 #endif

 #ifndef TARGET_OS
     #define TARGET_OS   HOST_OS
 #endif

 /* Directory name separator character   */

 #if HOST_OS == SYS_MS_DOS || HOST_OS == SYS_OS_2
     #define DIR_SEP     '\\'
 #elif  HOST_OS == SYS_UNIX
     #define DIR_SEP     '/'
 #elif  HOST_OS == SYS_VAX_VMS || HOST_OS == SYS_RSX
     #define DIR_SEP     ']'
 #endif

 #define   items(Array)   (sizeof Array/sizeof *Array)

#endif
